Attribute VB_Name = "ModRegistry"
Option Explicit
Public Sub SetUpIconDblClick()

    Dim RegData$, hKey&, Rv&
    Dim SA As SECURITY_ATTRIBUTES

    With SA
        .bInheritHandle = True
        .lpSecurityDescriptor = 0
        .nLength = Len(SA)
    End With

    ' Give Our File Extension To Reg.
    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, ".msf", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegSetValueEx hKey, vbNullString, 0, 1, "msffile", 7
       RegCloseKey hKey
    End If
    ' Tie It Up.
    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, "msffile", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegSetValueEx hKey, vbNullString, 0, 1, "MicroStudio File", 16
       RegCloseKey hKey
    End If

    ' Prep Default Icon String For Our Files.
    If Right(App.Path, 1) = "\" Then
       RegData = App.Path & "MicroStudio.exe,-10"  ' Icon Resource ID = 10, Therefore Specify -10.
    Else
       RegData = App.Path & "\MicroStudio.exe,-10"
    End If
    ' Write Default Icon Data.
    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, "msffile\DefaultIcon", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegSetValueEx hKey, vbNullString, 0, 1, RegData, Len(RegData)
       RegCloseKey hKey
    End If

    ' Set Up Icon Double Click. (Will Work When App Is An Exe).
    Rv = RegCreateKeyEx(HKEY_CLASSES_ROOT, "msffile\Shell\Open\Command", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       RegData = Left(RegData, Len(RegData) - 4)
       RegData = RegData & " %1"
       RegSetValueEx hKey, vbNullString, 0, 1, RegData, Len(RegData)
       RegCloseKey hKey
    End If

End Sub
Public Sub GetRecentFileList(MRec As Object)

    Dim K%, Pos%, N%
    Dim Buffer$, hKey&, Rv&

    N = 1

    Rv = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\" & TTL & "\Recent Files", 0, KEY_ALL_ACCESS, hKey)
    If Rv = 0 Then
       For K = 1 To 4
           Buffer = Space(MAX_PATH)
           Rv = RegQueryValueEx(hKey, CStr(K) & ".", 0, 0, Buffer, MAX_PATH)
           Pos = InStr(Buffer, vbNullChar)
           If Pos <> 0 Then
              MRec(0).Visible = 1
              MRec(N).Tag = Left(Buffer, Pos - 1)
              MRec(N).Caption = "&" & CStr(N) & " " & GetTitle(MRec(N).Tag)
              MRec(N).Visible = 1
              N = N + 1
           End If
           RegDeleteValue hKey, CStr(K) & "."
       Next
       RegCloseKey hKey
    End If

End Sub
Public Sub SaveRecentFileList(MRec As Object)

    Dim StrVal$, K%, hKey&, Rv&
    Dim SA As SECURITY_ATTRIBUTES

    SA.bInheritHandle = True
    SA.lpSecurityDescriptor = 0
    SA.nLength = Len(SA)

    Rv = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\" & TTL & "\Recent Files", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       For K = 1 To 4
           StrVal = MRec(K).Tag
           If StrVal = "" Then
              Exit For
           Else
              RegSetValueEx hKey, CStr(K) & ".", 0, 1, StrVal, Len(StrVal)
           End If
       Next
       RegCloseKey hKey
    End If

End Sub
Public Sub GetLastDir()

    Dim Buffer$, hKey&, Rv&
   
    ChDrive Left(App.Path, 3)
    ChDir App.Path

    Rv = RegOpenKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\" & TTL & "\Recent Folder", 0, KEY_ALL_ACCESS, hKey)
    If Rv = 0 Then
       Buffer = Space(MAX_PATH)
       Rv = RegQueryValueEx(hKey, "Folder", 0, 0, Buffer, MAX_PATH)
       If Rv = 0 Then
          On Error Resume Next
             Buffer = Left(Buffer, InStr(Buffer, vbNullChar) - 1)
             ChDrive Left(Buffer, 3)
             ChDir Buffer
             If Err.Number Then Err.Clear
          On Error GoTo 0
       End If
       RegDeleteValue hKey, "Folder"
       RegCloseKey hKey
    End If

End Sub
Public Sub SaveLastDir()

    Dim hKey&, Rv&, Folder$
    Dim SA As SECURITY_ATTRIBUTES

    SA.bInheritHandle = True
    SA.lpSecurityDescriptor = 0
    SA.nLength = Len(SA)

    Rv = RegCreateKeyEx(HKEY_CURRENT_USER, "Software\CyberVision\" & TTL & "\Recent Folder", 0, vbNullString, 0, KEY_ALL_ACCESS, SA, hKey, 0)
    If Rv = 0 Then
       Folder = CurDir
       RegSetValueEx hKey, "Folder", 0, 1, Folder, Len(Folder)
       RegCloseKey hKey
    End If

End Sub
