Attribute VB_Name = "ModSequencer"
Option Explicit
Public Sub PatternProc(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    Dim CurRow%, N%
    
    N = -1

    For CurRow = 0 To 74
        If CurRow < 24 Then
           With KitParams2(CurRow, CurPos)
                If .kiMidiMsgOn > 0 And Not KitParams1(CurRow).kiMute Then
                    midiOutShortMsg hMidiOut, .kiVelocity * &H10000 + .kiMidiMsgOn
                    midiOutShortMsg hMidiOut, .KiMidiMsgOff
                End If
           End With
        End If
        If CurRow Mod 5 = 0 Then N = N + 1
        With SynthParams3(CurRow, CurPos)
             If .MidiMsgOn > 0 And Not SynthParams1(N).siMute Then
                 midiOutShortMsg hMidiOut, SynthParams2(N, CurPos).siVelocity * &H10000 + .MidiMsgOn
                 NoteLens(CurRow, CurPos).ReleaseNote CurRow, SynthParams2(N, CurPos).siNoteLength * CurInterval, .MidiMsgOff
             End If
        End With
        If bDxAvailable Then
           If CurRow < 24 Then
              If WaveTriggers(CurRow, CurPos) And Not WaveMute(CurRow) Then
                 If WavePath(CurRow) <> "" Then
                    With WaveBuffers(CurRow)
                        .Stop
                        .SetCurrentPosition 0
                        .Play DSBPLAY_DEFAULT
                    End With
                 End If
              End If
           End If
        End If
    Next

    CurPos = CurPos + 1
    If CurPos > EndPos Then CurPos = StartPos

    If CurInterval <> PrevInterval Then
       timeKillEvent uId
       TimerID = timeSetEvent(CurInterval, BestRes, AddressOf PatternProc, 0, 1)
       PrevInterval = CurInterval
    End If

End Sub
Public Sub SongProc(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    Dim CurRow%, N%

    N = -1

    For CurRow = 0 To 74
        If CurRow < 24 Then
           With KitParams2(CurRow, SongPos)
                If .kiMidiMsgOn > 0 And Not KitParams1(CurRow).kiMute Then
                    midiOutShortMsg hMidiOut, .kiVelocity * &H10000 + .kiMidiMsgOn
                    midiOutShortMsg hMidiOut, .KiMidiMsgOff
                End If
           End With
        End If
        If CurRow Mod 5 = 0 Then N = N + 1
        With SynthParams3(CurRow, SongPos)
             If .MidiMsgOn > 0 And Not SynthParams1(N).siMute Then
                 midiOutShortMsg hMidiOut, SynthParams2(N, SongPos).siVelocity * &H10000 + .MidiMsgOn
                 NoteLens(CurRow, SongPos).ReleaseNote CurRow, SynthParams2(N, SongPos).siNoteLength * CurInterval, .MidiMsgOff
             End If
        End With
        If bDxAvailable Then
           If CurRow < 24 Then
              If WaveTriggers(CurRow, SongPos) And Not WaveMute(CurRow) Then
                 If WavePath(CurRow) <> "" Then
                    With WaveBuffers(CurRow)
                        .Stop
                        .SetCurrentPosition 0
                        .Play DSBPLAY_DEFAULT
                    End With
                 End If
              End If
           End If
        End If
    Next

    SongPos = SongPos + 1
    If SongPos > SongEndPos Then
       SongPtr = SongPtr + 1
       If SongPtr > 499 Or Song(SongPtr) = 0 Then
          If bLoopSong Then
             SongStartPos = (Song(0) - 1) * 16
             SongEndPos = SongStartPos + 15
             SongPos = SongStartPos
             SongPtr = 0
          Else
             FrmSong.TmrStop.Enabled = 1
             Exit Sub
          End If
       End If
       SongStartPos = (Song(SongPtr) - 1) * 16
       SongEndPos = SongStartPos + 15
       SongPos = SongStartPos
    End If

End Sub
Public Sub NoteOffProc1(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc2(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc3(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc4(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc5(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc6(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc7(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc8(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc9(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc10(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc11(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc12(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc13(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc14(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc15(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc16(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc17(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc18(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc19(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc20(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc21(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc22(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc23(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc24(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc25(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc26(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc27(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc28(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc29(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc30(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc31(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc32(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc33(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc34(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc35(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc36(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc37(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc38(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc39(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc40(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc41(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc42(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc43(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc44(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc45(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc46(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc47(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc48(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc49(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc50(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc51(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc52(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc53(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc54(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc55(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc56(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc57(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc58(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc59(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc60(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc61(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc62(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc63(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc64(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc65(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc66(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc67(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc68(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc69(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc70(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc71(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc72(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc73(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc74(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
Public Sub NoteOffProc75(ByVal uId&, ByVal uMsg&, ByVal dwUser&, ByVal dw1&, ByVal dw2&)

    midiOutShortMsg hMidiOut, dwUser
    timeKillEvent uId

End Sub
