VERSION 5.00
Begin VB.Form FrmTrackEdit 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Track Editor"
   ClientHeight    =   1605
   ClientLeft      =   2280
   ClientTop       =   1980
   ClientWidth     =   5370
   ControlBox      =   0   'False
   Icon            =   "FrmTrackEdit.frx":0000
   LockControls    =   -1  'True
   MaxButton       =   0   'False
   MinButton       =   0   'False
   NegotiateMenus  =   0   'False
   ScaleHeight     =   107
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   358
   ShowInTaskbar   =   0   'False
   Begin VB.VScrollBar VsbChannel 
      Height          =   195
      Left            =   1530
      Max             =   0
      Min             =   15
      TabIndex        =   11
      TabStop         =   0   'False
      Top             =   150
      Width           =   240
   End
   Begin VB.CheckBox ChkSustain 
      Caption         =   "Sustain"
      Height          =   195
      Left            =   1845
      TabIndex        =   10
      TabStop         =   0   'False
      Top             =   900
      UseMaskColor    =   -1  'True
      Width           =   825
   End
   Begin VB.VScrollBar VsbVolume 
      Height          =   195
      Left            =   1530
      Max             =   0
      Min             =   127
      TabIndex        =   5
      TabStop         =   0   'False
      Top             =   540
      Value           =   100
      Width           =   240
   End
   Begin VB.VScrollBar VsbPan 
      Height          =   195
      Left            =   3255
      Max             =   0
      Min             =   127
      TabIndex        =   4
      TabStop         =   0   'False
      Top             =   540
      Value           =   64
      Width           =   240
   End
   Begin VB.VScrollBar VsbModulation 
      Height          =   195
      Left            =   4980
      Max             =   0
      Min             =   127
      TabIndex        =   3
      TabStop         =   0   'False
      Top             =   540
      Width           =   240
   End
   Begin VB.CheckBox ChkPorta 
      Caption         =   "Portamento"
      Height          =   195
      Left            =   120
      TabIndex        =   2
      TabStop         =   0   'False
      Top             =   900
      Width           =   1110
   End
   Begin VB.VScrollBar VsbPorta 
      Height          =   195
      Left            =   1530
      Max             =   0
      Min             =   127
      TabIndex        =   1
      TabStop         =   0   'False
      Top             =   1260
      Width           =   240
   End
   Begin VB.CommandButton CmdOk 
      Caption         =   "&Ok"
      Height          =   375
      Left            =   3570
      TabIndex        =   0
      TabStop         =   0   'False
      Top             =   1110
      Width           =   1680
   End
   Begin VB.Label LblInstrument 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      ForeColor       =   &H00FFFF00&
      Height          =   255
      Left            =   1845
      LinkTimeout     =   0
      TabIndex        =   13
      Top             =   120
      Width           =   3405
   End
   Begin VB.Label LblChannel 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Channel 01"
      ForeColor       =   &H00FFFF00&
      Height          =   255
      Left            =   120
      LinkTimeout     =   0
      TabIndex        =   12
      Top             =   120
      Width           =   1680
   End
   Begin VB.Label LblPan 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Pan 00"
      ForeColor       =   &H00FFFF00&
      Height          =   255
      Left            =   1845
      LinkTimeout     =   0
      TabIndex        =   9
      Top             =   510
      Width           =   1680
   End
   Begin VB.Label LblVolume 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Volume 100"
      ForeColor       =   &H00FFFF00&
      Height          =   255
      Left            =   120
      LinkTimeout     =   0
      TabIndex        =   8
      Top             =   510
      Width           =   1680
   End
   Begin VB.Label LblModulation 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "Modulation 000"
      ForeColor       =   &H00FFFF00&
      Height          =   255
      Left            =   3570
      LinkTimeout     =   0
      TabIndex        =   7
      Top             =   510
      Width           =   1680
   End
   Begin VB.Label LblPorta 
      BackColor       =   &H00000000&
      BorderStyle     =   1  'Fixed Single
      Caption         =   "PortaTime 000"
      ForeColor       =   &H00FFFF00&
      Height          =   255
      Left            =   120
      LinkTimeout     =   0
      TabIndex        =   6
      Top             =   1230
      Width           =   1680
   End
End
Attribute VB_Name = "FrmTrackEdit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private bQuitSub As Boolean
Private Sub Form_Load()

    If FrmStudio.MnuViewAction(0).Checked Then
       VsbChannel.Value = 9
    Else
       If Channel = 0 Then
          VsbChannel_Change
       Else
          VsbChannel.Value = Channel
       End If
    End If

    Width = 5460
    Height = 1980
    PositionForm Me

End Sub
Private Sub VsbChannel_Change()

    Dim V%
    Dim bTempDirty As Boolean

    bTempDirty = bDirty

    V = VsbChannel.Value
    LblChannel.Caption = "Channel " & Format(V + 1, "00")

    If V = 9 Then
       LblInstrument.Caption = "Percusion"
       With KitEdit
            VsbVolume.Value = .keVolume
            VsbPan.Value = .kePan
            VsbModulation.Value = .keModulation
            VsbPorta.Value = .kePortaTime
            If .kePortaOnOff = 0 Then ChkPorta.Value = 0 Else ChkPorta.Value = 1
            If .keSustain = 0 Then ChkSustain.Value = 0 Else ChkSustain.Value = 1
       End With
    Else
       If V < 9 Then
          With SynthParams1(V)
               LblInstrument.Caption = .siPatchName
               VsbVolume.Value = .siVolume
               VsbPan.Value = .siPan
               VsbModulation.Value = .siModulation
               VsbPorta.Value = .siPortaTime
               If .siPortaOnOff = 0 Then ChkPorta.Value = 0 Else ChkPorta.Value = 1
               If .siSustain = 0 Then ChkSustain.Value = 0 Else ChkSustain.Value = 1
          End With
       Else
          If V > 9 Then
             With SynthParams1(V - 1)
                  LblInstrument.Caption = .siPatchName
                  VsbVolume.Value = .siVolume
                  VsbPan.Value = .siPan
                  VsbModulation.Value = .siModulation
                  VsbPorta.Value = .siPortaTime
                  If .siPortaOnOff = 0 Then ChkPorta.Value = 0 Else ChkPorta.Value = 1
                  If .siSustain = 0 Then ChkSustain.Value = 0 Else ChkSustain.Value = 1
             End With
          End If
       End If
    End If

    bDirty = bTempDirty

End Sub
Private Sub VsbVolume_Change()

    Dim Ch%, V%

    Ch = VsbChannel.Value
    V = VsbVolume.Value
    LblVolume.Caption = "Volume " & Format(V, "000")

    If Ch = 9 Then
       KitEdit.keVolume = V
    Else
       If Ch < 9 Then
          SynthParams1(Ch).siVolume = V
       Else
          SynthParams1(Ch - 1).siVolume = V
       End If
    End If

    midiOutShortMsg hMidiOut, V * &H10000 + CHANNEL_VOLUME_CONTROLLER * &H100 + &HB0 + Ch

    bDirty = True

End Sub
Private Sub VsbPan_Change()

    Dim Ch%, V%

    Ch = VsbChannel.Value
    V = VsbPan.Value
    LblPan.Caption = "Pan " & Format(V - 64, "00")

    If Ch = 9 Then
       KitEdit.kePan = V
    Else
       If Ch < 9 Then
          SynthParams1(Ch).siPan = V
       Else
          SynthParams1(Ch - 1).siPan = V
       End If
    End If

    midiOutShortMsg hMidiOut, V * &H10000 + CHANNEL_PAN_CONTROLLER * &H100 + &HB0 + Ch
    bDirty = True

End Sub
Private Sub VsbModulation_Change()

    Dim Ch%, V%

    Ch = VsbChannel.Value
    V = VsbModulation.Value
    LblModulation.Caption = "Modulation " & Format(V, "000")

    If Ch = 9 Then
       KitEdit.keModulation = V
    Else
       If Ch < 9 Then
          SynthParams1(Ch).siModulation = V
       Else
          SynthParams1(Ch - 1).siModulation = V
       End If
    End If

    midiOutShortMsg hMidiOut, V * &H10000 + CHANNEL_MODULATION_CONTROLLER * &H100 + &HB0 + Ch
    bDirty = True

End Sub
Private Sub VsbPorta_Change()

    Dim Ch%, V%

    Ch = VsbChannel.Value
    V = VsbPorta.Value
    LblPorta.Caption = "PortaTime " & Format(V, "000")

    If Ch = 9 Then
       KitEdit.kePortaTime = V
    Else
       If Ch < 9 Then
          SynthParams1(Ch).siPortaTime = V
       Else
          SynthParams1(Ch - 1).siPortaTime = V
       End If
    End If

    midiOutShortMsg hMidiOut, V * &H10000 + CHANNEL_PORTATIME_CONTROLLER * &H100 + &HB0 + Ch
    bDirty = True

End Sub
Private Sub ChkPorta_Click()

    Dim Ch%

    Ch = VsbChannel.Value

    If ChkPorta.Value = 0 Then
       If Ch = 9 Then
          KitEdit.kePortaOnOff = 0
       Else
          If Ch < 9 Then
             SynthParams1(Ch).siPortaOnOff = 0
          Else
             SynthParams1(Ch - 1).siPortaOnOff = 0
          End If
       End If
       midiOutShortMsg hMidiOut, CHANNEL_PORTAONOFF_CONTROLLER * &H100 + &HB0 + Ch
    End If

    If ChkPorta.Value = 1 Then
       If Ch = 9 Then
          KitEdit.kePortaOnOff = 127
       Else
          If Ch < 9 Then
             SynthParams1(Ch).siPortaOnOff = 127
          Else
             SynthParams1(Ch - 1).siPortaOnOff = 127
          End If
       End If
       midiOutShortMsg hMidiOut, 127 * &H10000 + CHANNEL_PORTAONOFF_CONTROLLER * &H100 + &HB0 + Ch
    End If

    bDirty = True

End Sub
Private Sub ChkSustain_Click()

    Dim Ch%

    Ch = VsbChannel.Value

    If ChkSustain.Value = 0 Then
       If Ch = 9 Then
          KitEdit.keSustain = 0
       Else
          If Ch < 9 Then
             SynthParams1(Ch).siSustain = 0
          Else
             SynthParams1(Ch - 1).siSustain = 0
          End If
       End If
       midiOutShortMsg hMidiOut, CHANNEL_SUSTAIN_CONTROLLER * &H100 + &HB0 + Ch
    End If

    If ChkSustain.Value = 1 Then
       If Ch = 9 Then
          KitEdit.keSustain = 127
       Else
          If Ch < 9 Then
             SynthParams1(Ch).siSustain = 127
          Else
             SynthParams1(Ch - 1).siSustain = 127
          End If
       End If
       midiOutShortMsg hMidiOut, 127 * &H10000 + CHANNEL_SUSTAIN_CONTROLLER * &H100 + &HB0 + Ch
    End If

    bDirty = True

End Sub
Private Sub CmdOk_Click()

    Unload Me

End Sub
